/*

	by Serge FANTINO - fantino@math.unice.fr
	
*/

#ifndef EXTENDED_MENU_H
#define EXTENDED_MENU_H

#include <InterfaceKit.h>

class KBitmapMenuItem : public BMenuItem {
public:
	KBitmapMenuItem(const char *label,BBitmap *bitmap,
		BMessage *message,char shortcut = NULL, uint32 modifiers = NULL);
	KBitmapMenuItem(const char *label,BBitmap *bitmap,
		BMenu *submenu,BMessage *message=NULL);
    virtual ~KBitmapMenuItem();
    
    void SetBitmap(BBitmap *bitmap);
    void ReleaseBitmap();
    const BBitmap *Bitmap();
    
    virtual void DrawContent(void);
    
protected:
    virtual void GetContentSize(float *width, float *height);
	
private:
	BBitmap	*fBitmap;
};

class KGroupMenuItem : public BMenuItem {
public:
	KGroupMenuItem(uint32 groupID,const char *label, BMessage *message, 
         char shortcut = NULL, uint32 modifiers = NULL);
         
    uint32 GroupID();
    
   	virtual void SetMarked(bool flag);
   	
private:
	uint32 fGroupID;
};

class KFontMenuItem : public BMenuItem {
public:
	KFontMenuItem(const char *label,BFont *font,BMessage *message);
	
	virtual void DrawContent(void);
	
	virtual void GetContentSize(float *width, float *height);
	
	virtual status_t Invoke(BMessage *message = NULL);
	
private:
	BFont fFont;
	font_height fHeight;
};

class KSkinMenu : public BMenu {
public:
	KSkinMenu(const char *name, menu_layout layout = B_ITEMS_IN_COLUMN);
	
	virtual void DrawBackground(BRect update);
};

#endif
