/*

	by Serge FANTINO - fantino@math.unice.fr
	
*/

#ifndef LABEL_VIEW_H
#define LABEL_VIEW_H

#include <InterfaceKit.h>
#include <SupportKit.h>

class KLabelView : public BView {
public:

	KLabelView(BRect frame,const char *name,const char *label,uint32 resizingMode=B_FOLLOW_LEFT|B_FOLLOW_TOP,uint32 flags=0);
	
	virtual void Draw(BRect updateRect);
	
	virtual void AttachedToWindow();
	
	virtual void SetLabel(const char *label);
	
	virtual void SetMarging(float left,float right=0);
	
	virtual void GetPreferredSize(float *width,float *height);
	
	virtual void FrameResized(float width, float height);

	virtual	void SetAlignment(alignment align);
	alignment Alignment() const;
	
private:

	typedef BView inherited;

	void update(bool redraw=false);

	BString		fLabel;
	float		fLeft,fRight;
	BPoint 		fBase;
	alignment	fAlign;
};

#endif