//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998-1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

/*

	this is the tips system:
	
*/

#ifndef TIPS_H
#define TIPS_H

#include <SupportKit.h>
#include <AppKit.h>
#include <InterfaceKit.h>

// display the tips in a pretty floatting window, with yellow bckgrnd...
class KTipsWindow : public BWindow {
public:
	
	KTipsWindow(BView *owner,BPoint where,const char *text);
	
	virtual void Quit();
	
};

class KTips;
class KTipsManager;

KTips *add_tips(const char *tips,BView *owner);

KTipsManager *tips_manager();

enum tips_state {
	K_TIPS_IDLE,
	K_TIPS_SHOWING,
	K_TIPS_HIDING
};

class KTipsManager : public BLooper {
public:

	static bool _init();

	KTips *AddTips(const char *tips,BView *owner);
	
	void Enable(bool flag);
	bool IsEnabled();
	
protected:

	friend KTips;
	
	KTips *create_tips(int32 ID,const char *tips,BView *owner,BView *target);
	
	virtual void ShowTips(KTips *tips,BPoint where);
	virtual void HideTips(bool force=false);
	
	virtual void MessageReceived(BMessage *message);
	
	virtual void Pulse();
	
private:

	friend KTipsManager *tips_manager();

	static KTipsManager	*fMainTipsManager;

	KTipsManager();
	virtual ~KTipsManager();

	BMessageRunner	*fPulser;

	bool	fEnabled;
	int32	fID,fCurrentID,fLastID;
	bool	fActive;
	KTips	*fCurrentTips;
	BPoint	fWhere;
	tips_state	fState;
	int32	fWait;
	KTipsWindow *fTipsWindow;
	
	BWindow	*fWindow;

};

// 
class KTips : public BMessageFilter {
public:

	KTips(int32 ID,const char *tipsText,BView *owner,KTipsManager *fManager);
	
	virtual filter_result Filter(BMessage *message, BHandler **target);
	
	const char *Text();
	void SetText(const char *tipsText);
	
	BView *Owner();
	
private:
	friend KTipsManager;
	
	int32	fID;
	bool	fSlaved;
	BString	fTipsText;
	BView	*fOwner;
	KTipsManager	*fManager;
};

#endif
