/*

	by Serge FANTINO - fantino@math.unice.fr
	
*/

#include "interface_kit_tools.h"

#include <Window.h>
#include <Screen.h>

void extend_view_by(BView *v,float x,float y,bool lock_size_limit)
{
	BView *vv=v;
	while (vv!=NULL) {
	
		if (vv->ResizingMode()==0) {// if we found a view with no resizing at all...
			// resize it...
			vv->ResizeBy(x,y);
			// and expect that further resizement will be done by someone... (a packer !)
			return;
		}
	
		vv=vv->Parent();
	}
	// ok, if all the ascendent view are well initialized,
	// extend the window ! (if any...)
	if (v->Window()!=NULL) {
		{
			BRect new_frame=v->Window()->Frame();
			new_frame.right+=x;
			new_frame.bottom+=y;
			BScreen screen;
			new_frame=new_frame&screen.Frame();
			v->Window()->ResizeTo(new_frame.Width(),new_frame.Height());
		}
		if (lock_size_limit) {
			float min_width,max_width,min_height,max_height;
			v->Window()->GetSizeLimits(&min_width,&max_width,&min_height,&max_height);
			v->Window()->SetSizeLimits(
				v->Window()->Bounds().Width(),max_width,
				v->Window()->Bounds().Height(),max_height);
		}
  	}
}
