/*

	by Serge FANTINO - fantino@math.unice.fr
	
*/

/*

	this is a Label, something that lack in the Be Zoo
	this is v0.1, a very simple thing that need to grow up !

*/

#include "label_view.h"

KLabelView::KLabelView(BRect frame,const char *name,const char *label,uint32 resizingMode,uint32 flags):
BView(frame,name,resizingMode,flags|B_WILL_DRAW)
{
	fLabel.SetTo(label);	
	fLeft=5;fRight=0;
	update();
}

void KLabelView::SetLabel(const char *label)
{
	fLabel.SetTo(label);
	update();
	//Invalidate();	
}

void KLabelView::Draw(BRect updateRect)
{
	FillRect(updateRect,B_SOLID_LOW);
	//StrokeRect(Bounds());
	//MovePenTo(Bounds().left+fLeft,Bounds().bottom-fBaseLine);
	MovePenTo(fBase);
	DrawString(fLabel.String());
}

void KLabelView::AttachedToWindow()
{
	BView::AttachedToWindow();
	if (Parent()!=NULL) {
		SetLowColor(Parent()->ViewColor());
		SetViewColor(Parent()->ViewColor());
	}
}

void KLabelView::SetMarging(float left,float right)
{
	fLeft=left;
	fRight=right;
	update();
}

void KLabelView::GetPreferredSize(float *width,float *height)
{
	//BView::GetPreferredSize(width,height);
	float w=StringWidth(fLabel.String());
	*width=w+fLeft+fRight;
	font_height h;
	GetFontHeight(&h);
	*height=(h.ascent+h.descent+h.leading)*1.5;
}

void KLabelView::SetAlignment(alignment align)
{
	fAlign=align;
	if (fAlign==B_ALIGN_RIGHT) SetFlags(Flags()^B_FRAME_EVENTS);
	else SetFlags(Flags()|B_FRAME_EVENTS);
	update();
}

alignment KLabelView::Alignment() const
{
	return fAlign;
}
	
void KLabelView::update(bool redraw)
{
	float w=StringWidth(fLabel.String());
	font_height h;
	GetFontHeight(&h);
	//
	fBase.y=h.ascent+(Bounds().Height()-(h.ascent+h.descent))/2;
	//fBase.y=Bounds().Height()/2;
	switch (fAlign) {
		case B_ALIGN_LEFT:
			fBase.x=fLeft;
			break;
		case B_ALIGN_RIGHT:
			fBase.x=Bounds().right-w-fRight;
			break;
		case B_ALIGN_CENTER:
			fBase.x=(Bounds().Width()-w)/2;
			break;
	}
	if (fBase.x<fLeft) fBase.x=fLeft;
	// --
	if (redraw) Draw(Bounds()); else Invalidate();
}

void KLabelView::FrameResized(float width, float height)
{
	inherited::FrameResized(width,height);
	update(true);
}



