//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998,1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

#include <InterfaceKit.h>
#include "scroll_view.h"

class KScrollView : public BScrollView {
public:
	KScrollView(const char *name, BView *target, 
  		uint32 resizingMode = B_FOLLOW_LEFT | B_FOLLOW_TOP, 
		uint32 flags = 0, 
		bool horizontal = false, 
		bool vertical = false, 
		border_style border = B_FANCY_BORDER)
	:BScrollView(name,target,resizingMode,flags,horizontal,vertical,border)
	{}
   
	KScrollView(BMessage *archive):BScrollView(archive) {};
	
	virtual void AttachedToWindow()
	{
		if (Parent()) {
			SetViewColor(Parent()->ViewColor());
		}
		BScrollView::AttachedToWindow();
	}
};

BScrollView *add_scrollview(
	BView *view,
	bool horizontal_scroller,
	bool vertical_scroller,
	border_style border)
{
	// ------- add scroller
	char name[200];
	uint32 resize=view->ResizingMode();
	view->SetResizingMode(B_FOLLOW_ALL_SIDES);
	BScrollView *sc=new KScrollView(name,view,resize,B_WILL_DRAW,horizontal_scroller,vertical_scroller,border);
	return sc;
};
