/*

	by Serge FANTINO - fantino@math.unice.fr
	
*/

#include "shrink_view.h"

KShrinkView::KShrinkView(BRect frame, const char *name,
		uint32 side,float height,orientation posture,
		uint32 resizingMode, 
		uint32 flags):
BView(frame,name,resizingMode,flags|B_WILL_DRAW)
{
	fPosture=posture;
	BRect header_frame,contains_frame;
	uint32 header_resizing;
	switch (side) {
		case K_BOTTOM:
			header_frame=BRect(0,frame.Height()-height,frame.Width(),frame.Height());
			contains_frame=BRect(0,0,frame.Width(),frame.Height()-height-1);
			header_resizing=B_FOLLOW_LEFT_RIGHT|B_FOLLOW_BOTTOM;
			break;
		case K_LEFT:
			header_frame=BRect(0,0,height,frame.Height());
			contains_frame=BRect(height+1,0,frame.Width(),frame.Height());
			header_resizing=B_FOLLOW_LEFT|B_FOLLOW_TOP_BOTTOM;
			break;
		case K_RIGHT:
			header_frame=BRect(frame.Width()-height,0,frame.Height(),frame.Width());
			contains_frame=BRect(0,0,frame.Width()-height-1,frame.Height());
			header_resizing=B_FOLLOW_RIGHT|B_FOLLOW_TOP_BOTTOM;
			break;
		case K_TOP:
		default:
			header_frame=BRect(0,0,frame.Width(),height);
			contains_frame=BRect(0,height+1,frame.Width(),frame.Height());
			header_resizing=B_FOLLOW_LEFT_RIGHT|B_FOLLOW_TOP;
			break;
	}
	//BView *header=new BView(header_frame,"_header_",header_resizing,flags);	
	fPackView=new KPackView(contains_frame,"_contains_",B_FOLLOW_ALL,flags);
	//AddChild(header);
	AddChild(fPackView);
}	

void KShrinkView::Shrink(bool flag)
{
	if (flag) {
		fPackView->Hide();
	} else {
		fPackView->Show();
	}
}
	
