//--------------------------------------------------------------------------
//
//			by Serge Fantino
//			fantino@math.unice.fr
//
//		Copyright 1998,1999, All Rights Reserved.
//
//--------------------------------------------------------------------------

#include <stdio.h>
#include <math.h>

#include <InterfaceKit.h>
#include <SupportDefs.h>
#include <ClassInfo.h>

#include "tab_view.h"
#include "pack_view.h"

KTab::KTab(BView * tabView):BTab(tabView){fFirstTime=true;};
KTab::KTab(BMessage *archive):BTab(archive){fFirstTime=true;}; 
    
void KTab::Deselect()
{
	BTab::Deselect();
}
    
void KTab::Select(BView *owner)
{

	if (!fFirstTime) {
		BTab::Select(owner);
	}

   	if (View()!=NULL&&owner->Window()!=NULL) {
    	BRect rect=owner->Bounds();
    	rect.InsetBy(5,5);
    	View()->MoveTo(rect.left,rect.top);
    	View()->ResizeTo(rect.Width(),rect.Height());
    }
   	
	if (fFirstTime) {
		BTab::Select(owner);
	}
	
    fFirstTime=false;
}

/*
void KTab::DrawTab(BView *owner,BRect frame,tab_position position,bool full)
{
	BTab::DrawTab(owner,frame,position,full);
	frame.PrintToStream();
}
*/

KTabView::KTabView(BRect frame, const char *name, 
         button_width width, 
         uint32 resizingMode, 
         uint32 flags):
     	BTabView(frame,name,width,resizingMode,flags)
{
}

void KTabView::AllAttached()
{}
void KTabView::AttachedToWindow()
{
	SetTabWidth(B_WIDTH_FROM_WIDEST);
	BTabView::AttachedToWindow();
}

void KTabView::AddTab(BView *target, BTab *tab)
{
	if (tab!=NULL)
		BTabView::AddTab(target,tab);
	else {
		//BTabView::AddTab(target,new KTab(target));
	
		KPackView *pack=dynamic_cast<KPackView *>(target);
		if (pack==NULL) {
			pack=new KPackView(target->Bounds(),target->Name());
			pack->PackChild(target,K_FULL,K_LEFT,K_FILL_BOTH);
		}
		BTabView::AddTab(pack,new KTab(pack));
	
	}
}

void KTabView::GetPreferredSize(float *width,float *height)
{
	//BTabView::GetPreferredSize(width,height);
	
	BRect frame=TabFrame(CountTabs()-1);
	BView *view=ViewForTab(Selection());
	if (view!=NULL) {
		view->GetPreferredSize(width,height);
		*width=max_c(*width+10,frame.right);
		*height=*height+frame.Height()+10;
	} else {
		BTabView::GetPreferredSize(width,height);
		*width=frame.right;
	}
}